"use strict";

exports.__esModule = true;
exports.markdownContentToString = markdownContentToString;
exports.writeMarkdown = writeMarkdown;
exports.writeMarkdownSync = writeMarkdownSync;

var _marked = require("marked");

exports.Token = _marked.Token;
exports.Tokens = _marked.Tokens;

var _writeFileSafe = require("write-file-safe");

exports.Options = _writeFileSafe.Options;

function markdownContentToString(content) {
  if (content === void 0) {
    content = "";
  }

  if (typeof content === "string") {
    return content;
  } else {
    return content.reduce(function (retval, item) {
      if (typeof item === "string") {
        return retval + item;
      } else {
        return retval + item.raw;
      }
    }, "");
  }
}

function writeMarkdown(path, content, options) {
  return (0, _writeFileSafe.writeFile)(path, markdownContentToString(content), options);
}

function writeMarkdownSync(path, content, options) {
  return (0, _writeFileSafe.writeFileSync)(path, markdownContentToString(content), options);
}